/*
 * Caveworld
 *
 * Copyright (c) 2014 kegare
 * https://github.com/kegare
 *
 * This mod is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL.
 * Please check the contents of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt
 */

package com.kegare.caveworld.block;

import net.minecraft.block.BlockDispenser;
import net.minecraft.dispenser.BehaviorDefaultDispenseItem;
import net.minecraft.dispenser.IBlockSource;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;

import com.kegare.caveworld.core.Config;
import com.kegare.caveworld.item.ItemPortalCaveworld;

import cpw.mods.fml.common.registry.GameRegistry;

public class CaveBlock
{
	public static BlockPortalCaveworld portalCaveworld;

	public static void initialize()
	{
		portalCaveworld = new BlockPortalCaveworld(Config.portalCaveworld, "portalCaveworld");
	}

	public static void configure()
	{
		GameRegistry.registerBlock(portalCaveworld, ItemPortalCaveworld.class, "caveworld_portal");

		BlockDispenser.dispenseBehaviorRegistry.putObject(Item.itemsList[portalCaveworld.blockID], new BehaviorDefaultDispenseItem()
		{
			@Override
			public ItemStack dispenseStack(IBlockSource blockSource, ItemStack itemstack)
			{
				EnumFacing facing = BlockDispenser.getFacing(blockSource.getBlockMetadata());
				World world = blockSource.getWorld();
				int x = blockSource.getXInt() + facing.getFrontOffsetX();
				int y = blockSource.getYInt() + facing.getFrontOffsetY();
				int z = blockSource.getZInt() + facing.getFrontOffsetZ();

				if (portalCaveworld.tryToCreatePortal(world, x, y, z))
				{
					--itemstack.stackSize;
				}

				return itemstack;
			}

			@Override
			public void playDispenseSound(IBlockSource blockSource)
			{
				super.playDispenseSound(blockSource);

				blockSource.getWorld().playSoundEffect(blockSource.getXInt(), blockSource.getYInt(), blockSource.getZInt(), portalCaveworld.stepSound.getPlaceSound(), 1.0F, 2.0F);
			}
		});
	}
}