/*
 * Caveworld
 *
 * Copyright (c) 2014 kegare
 * https://github.com/kegare
 *
 * This mod is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL.
 * Please check the contents of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt
 */

package com.kegare.caveworld.plugin;

import java.util.logging.Level;

import com.kegare.caveworld.util.CaveLog;

import cpw.mods.fml.common.Loader;

public abstract class CaveModPlugin
{
	public final String pluginModId;
	private final Class pluginHandler;

	public CaveModPlugin(String modid, Class clazz)
	{
		this.pluginModId = modid;
		this.pluginHandler = clazz;
	}

	public String getPluginVersion()
	{
		return Loader.instance().getIndexedModList().get(pluginModId).getVersion();
	}

	public ICaveModPluginHandler getPluginHandler()
	{
		ICaveModPluginHandler handler = null;

		try
		{
			handler = (ICaveModPluginHandler)pluginHandler.newInstance();
		}
		catch (Exception e)
		{
			CaveLog.log(Level.WARNING, e, "An error occurred trying to register %s plugin", pluginModId);

			handler = null;
		}

		return handler;
	}

	public abstract void configure(boolean flag);
}