/*
 * Caveworld
 *
 * Copyright (c) 2014 kegare
 * https://github.com/kegare
 *
 * This mod is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL.
 * Please check the contents of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt
 */

package com.kegare.caveworld.plugin.thaumcraft;

import java.util.regex.Pattern;

import org.apache.commons.lang3.math.NumberUtils;

import thaumcraft.api.ThaumcraftApi;
import thaumcraft.api.aspects.Aspect;
import thaumcraft.api.aspects.AspectList;

import com.google.common.base.Strings;
import com.kegare.caveworld.block.CaveBlock;
import com.kegare.caveworld.plugin.ICaveModPluginHandler;

public class ThaumcraftPluginHandler extends ThaumcraftPlugin implements ICaveModPluginHandler
{
	@Override
	public void register()
	{
		String version = getPluginVersion();
		version = Pattern.compile("^[0-9]").matcher(Strings.nullToEmpty(version)).replaceAll("");

		if (Strings.isNullOrEmpty(version) || NumberUtils.toInt(version) < 405)
		{
			return;
		}

		ThaumcraftApi.registerObjectTag(CaveBlock.portalCaveworld.blockID, 0, new AspectList().add(Aspect.TRAVEL, 4).add(Aspect.MINE, 4));
	}
}